#!/usr/bin/env python3

from os import getpid
from subprocess import getoutput
from sys import stdout

freecmd = 'grep ^MemFree /proc/meminfo | tr -s " " | cut -f2 -d" "'
pid = getpid()
vmsizecmd = 'grep ^VmSize /proc/%d/status | tr -s " " | cut -f2 -d" "' % pid

free1 = getoutput (freecmd)
print ("Start: %7s KByte frei    (MemFree)" % free1)

vmsize1 = getoutput (vmsizecmd)
print ("Start: %7s KByte benutzt (VmSize)" % vmsize1)

mega=1024*1024

arr = []
for i in range(100):
    arr.append (mega * "a")
    free = getoutput (freecmd)
    if (i % 10 == 9):
        print ("<%d>%s" % (i+1,free), end=", ")
        stdout.flush()
print()

print ("Ende:  %7s KByte frei    (MemFree)" % free)

vmsize2 = getoutput (vmsizecmd)
print ("Ende:  %7s KByte benutzt (VmSize)" % vmsize2)

diff_free = int(free1)-int(free)
diff_vmsize = int(vmsize2)-int(vmsize1)

print ("Differenz (frei):   %6d KByte = %6.2f MByte" % (diff_free, diff_free/1024.0))
print ("Differenz (vmsize): %6d KByte = %6.2f MByte" % (diff_vmsize, diff_vmsize/1024.0))

